SystemOrganization addCategory: #ConfigurationOfFFI!

Object subclass: #ConfigurationOfFFI
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfFFI'!

!ConfigurationOfFFI class methodsFor: 'private' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfFFI class methodsFor: 'private' stamp: 'DaleHenrichs 1/6/2010 16:45'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.15"
			self bootstrapPackage: 'Gofer-lr.83' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfFFI class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfFFI class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfFFI class methodsFor: 'loading' stamp: 'spd 6/9/2012 14:12'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfFFI class methodsFor: 'metacello tool support' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfFFI class methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
project

	^self new project! !

!ConfigurationOfFFI methodsFor: 'baselines' stamp: 'tbn 2/22/2010 01:18'!
baseline10: spec
    <version: '1.0-baseline'>
    
    spec for: #squeakCommon do: [
        spec blessing: #baseline.
        spec description: 'FFI-Examples removed from repository!!'.
        spec repository: 'http://source.squeakfoundation.org/FFI'.
        
        spec package: 'FFI-Pools'.
        spec package: 'FFI-Kernel'.
        spec package: 'FFI-Tests'.
        spec package: 'FFI-Examples' with: [ 
            spec postLoadDoIt: #ffiExampleInitialization10 ] ]
        
! !

!ConfigurationOfFFI methodsFor: 'baselines' stamp: 'spd 6/9/2012 13:50'!
baseline12: spec
	<version: '1.2-baseline'>
    
	spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec repository: 'http://source.squeakfoundation.org/FFI'.
		spec postLoadDoIt: #ffiExampleInitialization10.
        
		spec
			package: 'FFI-Pools';
			package: 'FFI-Kernel' with: [ spec requires: 'FFI-Pools' ];
			package: 'FFI-Tests' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-MacOS' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-Unix' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-Win32' with: [ spec requires: 'FFI-Kernel' ].
		
		spec
			group: 'Core' with: #('FFI-Pools' 'FFI-Kernel');
			group: 'Examples' with: #('FFI-MacOS' 'FFI-Unix' 'FFI-Win32');
			group: 'Tests' with: #('FFI-Tests') ].! !

!ConfigurationOfFFI methodsFor: 'baselines' stamp: 'spd 6/9/2012 12:35'!
baseline13: spec
	<version: '1.3-baseline'>
    
	spec for: #squeakCommon do: [
		spec blessing: #baseline.
		spec description: 'Explicit dependencies & groups'.
		spec repository: 'http://source.squeakfoundation.org/FFI'.
		spec postLoadDoIt: #ffiExampleInitialization10.
        
		spec
			package: 'FFI-Pools';
			package: 'FFI-Kernel' with: [ spec requires: 'FFI-Pools' ];
			package: 'FFI-Tests' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-MacOS' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-Unix' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-Win32' with: [ spec requires: 'FFI-Kernel' ].
		
		spec
			group: 'default' with: #('Core' 'Examples');
			group: 'Core' with: #('FFI-Pools' 'FFI-Kernel');
			group: 'Examples' with: #('FFI-MacOS' 'FFI-Unix' 'FFI-Win32');
			group: 'Tests' with: #('FFI-Tests') ].! !

!ConfigurationOfFFI methodsFor: 'baselines' stamp: 'dkh 7/30/2014 10:26'!
baseline14: spec
	<version: '1.4-baseline'>
    
	spec for: #common do: [
		spec blessing: #baseline.
		spec description: 'Explicit dependencies & groups'.
		spec repository: 'http://source.squeakfoundation.org/FFI'.
		spec postLoadDoIt: #ffiExampleInitialization10.
  
		spec
			package: 'FFI-Pools';
			package: 'FFI-Kernel' with: [ spec requires: 'FFI-Pools' ];
			package: 'FFI-Tests' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-MacOS' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-Unix' with: [ spec requires: 'FFI-Kernel' ];
			package: 'FFI-Win32' with: [ spec requires: 'FFI-Kernel' ].
		
		spec
			group: 'default' with: #('Core' 'Examples' 'Tests');
			group: 'Core' with: #('FFI-Pools' 'FFI-Kernel');
			group: 'Examples' with: #('FFI-MacOS' 'FFI-Unix' 'FFI-Win32');
			group: 'Tests' with: #('FFI-Tests') ].
	spec for: #pharo do: [
		spec
			package: 'AST-FFI-Pharo30Compatibility' with: [ 
				spec repository: 'http://smalltalkhub.com/mc/PharoExtras/FFICompatibility/main'];
			package: 'FFI-Kernel' with: [
				spec requires: #('AST-FFI-Pharo30Compatibility')]
			].! !

!ConfigurationOfFFI methodsFor: 'symbolic versions' stamp: 'EstebanLorenzano 2/11/2015 13:37'!
development: spec
    <symbolicVersion: #development>

    spec for: #common version: '1.4-baseline'.! !

!ConfigurationOfFFI methodsFor: 'doits' stamp: 'EstebanLorenzano 12/7/2009 22:49'!
ffiExampleInitialization10
	(Smalltalk at: #ExternalType) initialize.
	(Smalltalk at: #ExternalStructure) compileAllFields.
	Smalltalk recreateSpecialObjectsArray! !

!ConfigurationOfFFI methodsFor: 'accessing' stamp: 'EstebanLorenzano 12/7/2009 22:47'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear.
		project ]! !

!ConfigurationOfFFI methodsFor: 'symbolic versions' stamp: 'EstebanLorenzano 2/11/2015 13:37'!
stable: spec
	<symbolicVersion: #'stable'>
	
	spec for: #pharo version: '1.7'.
	spec for: #'pharo3.x' version: '1.8'.
	spec for: #'pharo4.x' version: '1.9'.
	spec for: #squeakCommon version: '1.5'.
	! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'DaleHenrichs 2/16/2010 20:57'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #broken.
      	spec description: 'FFI-Examples removed from repository!!'.
  		
		spec package: 'FFI-Pools' with: 'FFI-Pools-ar.1'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-ar.12'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-ar.3'.
		spec package: 'FFI-Examples' with: 'FFI-Examples-ar.1' ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 2/22/2010 01:18'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
     	spec description: 'FFI-Examples removed from repository!!'.
 		
		spec package: 'FFI-Pools' with: 'FFI-Pools-ar.1'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-ar.13'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-ar.3'.
		spec package: 'FFI-Examples' with: 'FFI-Examples-ar.1' ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 5/14/2010 11:33'!
version12: spec
	<version: '1.2' imports: #('1.2-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: '- Remove the Examples package
		- Added postLoadDoIt to project level
		- no underscore assignments'.
		
		spec package: 'FFI-Pools' with: 'FFI-Pools-ar.1'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-ar.13'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-ar.3'.
		spec package: 'FFI-MacOS' with: 'FFI-MacOS-ar.3'.
		spec package: 'FFI-Unix' with: 'FFI-Unix-tbn.3'.
		spec package: 'FFI-Win32' with: 'FFI-Win32-ar.3'. 
		
		 ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 8/4/2010 16:09'!
version13: spec
	<version: '1.3' imports: #('1.2-baseline')>
	
	spec for: #common do: [
		spec blessing: #release.
		spec description: 'Compliant with Pharo 1.1'.
		
		spec package: 'FFI-Pools' with: 'FFI-Pools-eem.2'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-tbn.20'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-jcg.4'.
		spec package: 'FFI-MacOS' with: 'FFI-MacOS-spd.5'.
		spec package: 'FFI-Unix' with: 'FFI-Unix-tbn.3'.
		spec package: 'FFI-Win32' with: 'FFI-Win32-ar.3'. 
		
		 ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 11/17/2010 15:44'!
version14: spec
	<version: '1.4' imports: #('1.2-baseline')>
	
	spec for: #common do: [
		spec blessing: #development.
		spec description: 'A few enhancements'.
		
		spec package: 'FFI-Pools' with: 'FFI-Pools-eem.2'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-ar.22'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-jcg.4'.
		spec package: 'FFI-MacOS' with: 'FFI-MacOS-spd.5'.
		spec package: 'FFI-Unix' with: 'FFI-Unix-tbn.3'.
		spec package: 'FFI-Win32' with: 'FFI-Win32-tbn.5'. 
		
		 ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'cwp 8/24/2011 15:19'!
version15: spec
	<version: '1.5' imports: #('1.2-baseline')>
	
	spec for: #common do: 
		[spec blessing: #development.
		spec description: 'Incorporate error reporting from Eliot'.
		
		spec package: 'FFI-Pools' with: 'FFI-Pools-eem.3'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-eem.24'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-jcg.4'.
		spec package: 'FFI-MacOS' with: 'FFI-MacOS-spd.5'.
		spec package: 'FFI-Unix' with: 'FFI-Unix-tbn.3'.
		spec package: 'FFI-Win32' with: 'FFI-Win32-tbn.5']! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 7/6/2012 09:06'!
version16: spec
	<version: '1.6' imports: #('1.2-baseline')>
	
	spec for: #pharo do: 
		[spec blessing: #release.
		spec description: 'Use latest packages'.
		
		spec package: 'FFI-Pools' with: 'FFI-Pools-eem.3'.
		spec package: 'FFI-Kernel' with: 'FFI-Kernel-tbn.25'.
		spec package: 'FFI-Tests' with: 'FFI-Tests-tbn.6'.
		spec package: 'FFI-MacOS' with: 'FFI-MacOS-spd.5'.
		spec package: 'FFI-Unix' with: 'FFI-Unix-mtf.4'.
		spec package: 'FFI-Win32' with: 'FFI-Win32-tbn.10'].

	"According to spd this version will not work for Squeak due to Win32 examples"
	spec for: #squeakCommon do: 
		[spec blessing: #broken ].! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'tbn 8/8/2012 15:00'!
version17: spec
	<version: '1.7' imports: #('1.3-baseline')>
	
	spec for: #squeakCommon do: [
		spec blessing: #release.
		spec description: 'Use latest packages that work out of the box'.
		
		spec
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'FFI-Kernel' with: 'FFI-Kernel-tbn.25';
			package: 'FFI-Tests' with: 'FFI-Tests-tbn.6';
			package: 'FFI-MacOS' with: 'FFI-MacOS-spd.5';
			package: 'FFI-Unix' with: 'FFI-Unix-mtf.4'].

	spec for: #pharo do: [
		spec package: 'FFI-Win32' with: 'FFI-Win32-tbn.11'	
	].	

	"Squeak is not able to handle latest Examples"
	spec for: #squeakCommon do: [ 
		spec
			package: 'FFI-Win32' with: 'FFI-Win32-mtf.8' ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'GuillermoPolito 12/20/2013 14:54'!
version18: spec
	<version: '1.8' imports: #('1.4-baseline')>
	
	spec for: #squeakCommon do: [
		spec blessing: #release.
		spec description: 'Use latest packages that work out of the box'.
		
		spec			
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'FFI-Kernel' with: 'FFI-Kernel-tbn.25';
			package: 'FFI-Tests' with: 'FFI-Tests-tbn.6';
			package: 'FFI-MacOS' with: 'FFI-MacOS-spd.5';
			package: 'FFI-Unix' with: 'FFI-Unix-mtf.4'].

	spec for: #pharo do: [
		spec
			package: 'FFI-Win32' with: 'FFI-Win32-tbn.11';
			package: 'AST-FFI-Pharo30Compatibility' with: 'AST-FFI-Pharo30Compatibility-ClementBera.4'.
	].	

	"Squeak is not able to handle latest Examples"
	spec for: #squeakCommon do: [ 
		spec
			package: 'FFI-Win32' with: 'FFI-Win32-mtf.8' ]! !

!ConfigurationOfFFI methodsFor: 'versions' stamp: 'EstebanLorenzano 2/11/2015 13:37'!
version19: spec
	<version: '1.9' imports: #('1.4-baseline')>
	
	spec for: #squeakCommon do: [
		spec blessing: #release.
		
		spec			
			package: 'FFI-Pools' with: 'FFI-Pools-eem.3';
			package: 'FFI-Kernel' with: 'FFI-Kernel-tbn.25';
			package: 'FFI-Tests' with: 'FFI-Tests-tbn.6';
			package: 'FFI-MacOS' with: 'FFI-MacOS-spd.5';
			package: 'FFI-Unix' with: 'FFI-Unix-mtf.4'].

	spec for: #pharo do: [
		spec
			package: 'FFI-Win32' with: 'FFI-Win32-tbn.11';
			package: 'AST-FFI-Pharo30Compatibility' 
				with: 'AST-FFI-Pharo30Compatibility-EstebanLorenzano.5'.
	].	

	"Squeak is not able to handle latest Examples"
	spec for: #squeakCommon do: [ 
		spec
			package: 'FFI-Win32' with: 'FFI-Win32-mtf.8' ]! !
